# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

V__DJUNCT_4D_SLICES_TO_3D_VOL_METADATA = Metadata(
    id="e85dbe20324eef240907de23abb203630c5e1180.boutiques",
    name="@djunct_4d_slices_to_3d_vol",
    package="afni",
    container_image_tag="afni/afni_make_build:AFNI_24.2.06",
)


VDjunct4dSlicesTo3dVolParameters = typing.TypedDict('VDjunct4dSlicesTo3dVolParameters', {
    "__STYX_TYPE__": typing.Literal["@djunct_4d_slices_to_3d_vol"],
    "do_something": bool,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "@djunct_4d_slices_to_3d_vol": v__djunct_4d_slices_to_3d_vol_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "@djunct_4d_slices_to_3d_vol": v__djunct_4d_slices_to_3d_vol_outputs,
    }.get(t)


class VDjunct4dSlicesTo3dVolOutputs(typing.NamedTuple):
    """
    Output object returned when calling `v__djunct_4d_slices_to_3d_vol(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    outfile: OutputPathType
    """Output file generated by the tool"""


def v__djunct_4d_slices_to_3d_vol_params(
    do_something: bool = False,
) -> VDjunct4dSlicesTo3dVolParameters:
    """
    Build parameters.
    
    Args:
        do_something: Do something really useful.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "@djunct_4d_slices_to_3d_vol",
        "do_something": do_something,
    }
    return params


def v__djunct_4d_slices_to_3d_vol_cargs(
    params: VDjunct4dSlicesTo3dVolParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("@djunct_4d_slices_to_3d_vol")
    if params.get("do_something"):
        cargs.append("-do-something")
    return cargs


def v__djunct_4d_slices_to_3d_vol_outputs(
    params: VDjunct4dSlicesTo3dVolParameters,
    execution: Execution,
) -> VDjunct4dSlicesTo3dVolOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = VDjunct4dSlicesTo3dVolOutputs(
        root=execution.output_file("."),
        outfile=execution.output_file("output_file"),
    )
    return ret


def v__djunct_4d_slices_to_3d_vol_execute(
    params: VDjunct4dSlicesTo3dVolParameters,
    execution: Execution,
) -> VDjunct4dSlicesTo3dVolOutputs:
    """
    Tool description goes here.
    
    Author: AFNI Developers
    
    URL: https://afni.nimh.nih.gov/
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `VDjunct4dSlicesTo3dVolOutputs`).
    """
    params = execution.params(params)
    cargs = v__djunct_4d_slices_to_3d_vol_cargs(params, execution)
    ret = v__djunct_4d_slices_to_3d_vol_outputs(params, execution)
    execution.run(cargs)
    return ret


def v__djunct_4d_slices_to_3d_vol(
    do_something: bool = False,
    runner: Runner | None = None,
) -> VDjunct4dSlicesTo3dVolOutputs:
    """
    Tool description goes here.
    
    Author: AFNI Developers
    
    URL: https://afni.nimh.nih.gov/
    
    Args:
        do_something: Do something really useful.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `VDjunct4dSlicesTo3dVolOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(V__DJUNCT_4D_SLICES_TO_3D_VOL_METADATA)
    params = v__djunct_4d_slices_to_3d_vol_params(
        do_something=do_something,
    )
    return v__djunct_4d_slices_to_3d_vol_execute(params, execution)


__all__ = [
    "VDjunct4dSlicesTo3dVolOutputs",
    "VDjunct4dSlicesTo3dVolParameters",
    "V__DJUNCT_4D_SLICES_TO_3D_VOL_METADATA",
    "v__djunct_4d_slices_to_3d_vol",
    "v__djunct_4d_slices_to_3d_vol_params",
]
